#define		ALLOCATE
#include	"main.h"


/**************************************************************
*
*	Functi apelate in sursa lex
*
**************************************************************/

// token ID, ID_INT, ID_FLOAT , ID_STRING , ID_BOOL
int
	lex_token_id	(
					Program*		pPrg,
					YYSTYPE*		yylval,
					char*			strToken
					)
	{
	VarList		*pTemp;

	// daca variabila este declarata deja,  este intors tipul ei
	// se cauta in lista de parametrii
	pTemp = pPrg->pParamList;
	while ( pTemp )
		{
		if (!_stricmp(pTemp->Nume,strToken))
			{
			yylval->PtrVar = pTemp;
			switch (pTemp->Tip)
				{
				case	TYPE_INT:		return	ID_INT;
				case	TYPE_FLOAT:		return	ID_FLOAT;
				case	TYPE_STRING:	return	ID_STRING;
				case	TYPE_BOOL:		return	ID_BOOL;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
					return -1;
				}
			}
		pTemp = pTemp->pNext;
		}
	// se cauta in lista de variabile
	pTemp = pPrg->pVarList;
	while ( pTemp )
		{
		if (!_stricmp(pTemp->Nume,strToken))
			{
			yylval->PtrVar = pTemp;
			switch (pTemp->Tip)
				{
				case	TYPE_INT:		return	ID_INT;
				case	TYPE_FLOAT:		return	ID_FLOAT;
				case	TYPE_STRING:	return	ID_STRING;
				case	TYPE_BOOL:		return	ID_BOOL;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
					return -1;
				}
			}
		pTemp = pTemp->pNext;
		}

	//	daca variabila nu e declarata este intors un tip generic
	yylval->VarName = strdup(strToken);
	return ID;
	}

// token FLOAT
int
	lex_token_float	( YYSTYPE* yylval,char* strToken )
	{
		yylval->FloatVal = atof(strToken);
		return	CT_FLOAT;
	}

// token INT
int
	lex_token_int	(YYSTYPE* yylval, char* strToken )
	{
		yylval->IntVal = atol(strToken);
		return	CT_INT;
	}

// token STRING
char*
	lex_token_string_concat( char* strCt1, char* strCt2 )
	{
		char*	pTemp;
		pTemp = (char*)malloc(strlen(strCt1)+strlen(strCt2)+1);
		strcpy(pTemp,strCt1);
		strcat(pTemp,strCt2);
		free(strCt1);
		return pTemp;
	}

//	cautare cuvinte rezervate in lista
int
	lex_token_res_word( char*	ResWord, int size)
{
	int			i;
	for(i=0;i<size;i++)
		if (!_stricmp(ResWordList[i].word, ResWord))
			return ResWordList[i].token;
	return 0;
}

/***************************************************************
*
*	Functi apelate in sursa yacc
*
****************************************************************/
// adauga o variabila la lista de variabile
void
	AddToVarList	(
					Program*		pPrg,
					char*			Name,
					int				Tip
					)
	{
	VarList			*pTemp;
	pTemp = (VarList*)malloc(sizeof(VarList));

	pTemp->TipSpec = TipNon;
	pTemp->Tip = Tip;
	pTemp->Nume = Name;
	pTemp->pNext = pPrg->pVarList;
	pPrg->pVarList = pTemp;

	// initializarea variabilei
	switch ( Tip )
		{
		case TYPE_FLOAT:
			pTemp->Float=0;
			break;
		case TYPE_INT:
			pTemp->Int=0;
			break;
		case TYPE_STRING:
			pTemp->String=strdup("");
			break;
		case TYPE_BOOL:
			pTemp->Boolean=FALSE;
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}

// adauga un parametru la lista de parametrii
void
	AddToParamList	(
					Program*		pPrg,
					char*			Name,
					int				Tip,
					TipParamSpec	TipSpec
					)
	{
	VarList				*pTemp,*pTempLast;
	pTemp = (VarList*)malloc(sizeof(VarList));

	pTemp->TipSpec = TipSpec;
	pTemp->Tip = Tip;
	pTemp->Nume = Name;
	pTemp->pNext = (VarList*)NULL;
	if(!pPrg->pParamList)
		pPrg->pParamList = pTemp;
	else
		{
		pTempLast = pPrg->pParamList;
		while(pTempLast->pNext)
			pTempLast = pTempLast->pNext;
		pTempLast->pNext = pTemp;
		}

	// initializarea parametrului
	switch ( Tip )
		{
		case TYPE_FLOAT:
			pTemp->Float=0;
			break;
		case TYPE_INT:
			pTemp->Int=0;
			break;
		case TYPE_STRING:
			pTemp->String=strdup("");
			break;
		case TYPE_BOOL:
			pTemp->Boolean=FALSE;
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


//	Dezalocarea listei de variabile
void
	FreeVarList(Program*	pPrg)
	{
	VarList*		pTemp;
	pTemp = pPrg->pVarList;
	while ( pTemp )
		{
		pPrg->pVarList = pTemp->pNext;

		free(pTemp->Nume);
		switch ( pTemp->Tip )
			{
			case TYPE_STRING:
				free(pTemp->String);
				break;
			}
		free(pTemp);
		pTemp = pPrg->pVarList;
		}
	}

//	Dezalocarea listei de parametrii
void
	FreeParamList(Program*	pPrg)
	{
	VarList*		pTemp;
	pTemp = pPrg->pParamList;
	while ( pTemp )
		{
		pPrg->pParamList = pTemp->pNext;

		free(pTemp->Nume);
		switch ( pTemp->Tip )
			{
			case TYPE_STRING:
				free(pTemp->String);
				break;
			}
		free(pTemp);
		pTemp = pPrg->pParamList;
		}
	}


/*------------------------------------------------------
*
*	Functii de gestiune a tipului numeric
*
*-----------------------------------------------------*/

// creaza un nod de tip operator numeric cu n operanzi
GenNumNode*
	NewOprNode	(
				long		TipOpr,
				long		NrOpd,
				...
				)
	{
	OprNumNode*		pTempNode;
	GenNumNode*		pTempGen;
	va_list			ArgList;
	int				i;

	pTempNode = (OprNumNode*)malloc(sizeof(OprNumNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodOpr;
	pTempNode->Opr = TipOpr;
	pTempNode->NrOpd = NrOpd;

	va_start(ArgList,NrOpd);
	for( i=0; i<NrOpd ; i++ )
		{
		pTempGen = va_arg(ArgList,GenNumNode*);
		pTempNode->NodList[i] = pTempGen;
		}
	va_end(ArgList);

	return	(GenNumNode*)pTempNode;
	}

// creaza un nod de tip constanta intreaga
GenNumNode*
	NewCtIntNode(
				long		ValOpd
				)
	{
	CtIntNode*		pTempNode;

	pTempNode = (CtIntNode*)malloc(sizeof(CtIntNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodCtInt;
	pTempNode->Val = ValOpd;

	return	(GenNumNode*)pTempNode;
	}

// creaza un nod de tip constanta float
GenNumNode*
	NewCtFloatNode	(
					double		ValOpd
					)
{
	CtFloatNode*		pTempNode;

	pTempNode = (CtFloatNode*)malloc(sizeof(CtFloatNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodCtFloat;
	pTempNode->Val = ValOpd;

	return	(GenNumNode*)pTempNode;
}


// creaza un nod de tip variabila numerica
GenNumNode*
	NewIdNode	(
				VarList*		pIdOpd
				)
{
	VarNumNode*		pTempNode;

	pTempNode = (VarNumNode*)malloc(sizeof(VarNumNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodVar;
	pTempNode->pVar = pIdOpd;

	return	(GenNumNode*)pTempNode;
}



// Face conversia de la float la intreg
EvalNumStruct
	ConvertFloatToInt(EvalNumStruct  NumOpd)
	{
	switch (NumOpd.Tip)
		{
		case	TipInt:
			break;
		case	TipFloat:
			NumOpd.Tip = TipInt;
			NumOpd.Int = (long)NumOpd.Float;
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	return NumOpd;
	}

// Face conversia de la intreg la float
EvalNumStruct
	ConvertIntToFloat(EvalNumStruct  NumOpd)
	{
	switch (NumOpd.Tip)
		{
		case	TipInt:
			NumOpd.Tip = TipFloat;
			NumOpd.Float = (double)NumOpd.Int;
			break;
		case	TipFloat:
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	return NumOpd;
	}

// evalueaza un arbore de tip expresie numerica
EvalNumStruct
	EvalExprNumTree(GenNumNode*		pNumTree)
	{
	EvalNumStruct		TempEval;
	memset((void*)&TempEval,sizeof(EvalNumStruct),0);

	switch(pNumTree->Tip)
		{
		case TipNodOpr:
			{
			OprNumNode	Temp=*((OprNumNode*)pNumTree);

			switch(Temp.Opr)
				{
				case	ADD:
					{
					EvalNumStruct		TempEvalP1,TempEvalP2;

					TempEvalP1 = EvalExprNumTree(Temp.NodList[0]);
					TempEvalP2 = EvalExprNumTree(Temp.NodList[1]);

					if (TempEvalP1.Tip == TipFloat || TempEvalP2.Tip == TipFloat)
						{
						TempEval.Tip =	TipFloat;
						TempEval.Float =
								ConvertIntToFloat(TempEvalP1).Float +
								ConvertIntToFloat(TempEvalP2).Float;
						}
					else
						{
						TempEval.Tip =	TipInt;
						TempEval.Int = 	TempEvalP1.Int + TempEvalP2.Int;
						}
					}
					break;
				case	SUB:
					{
					EvalNumStruct		TempEvalP1,TempEvalP2;

					TempEvalP1 = EvalExprNumTree(Temp.NodList[0]);
					TempEvalP2 = EvalExprNumTree(Temp.NodList[1]);

					if (TempEvalP1.Tip == TipFloat || TempEvalP2.Tip == TipFloat)
						{
						TempEval.Tip =	TipFloat;
						TempEval.Float =
								ConvertIntToFloat(TempEvalP1).Float -
								ConvertIntToFloat(TempEvalP2).Float;
						}
					else
						{
						TempEval.Tip =	TipInt;
						TempEval.Int = 	TempEvalP1.Int - TempEvalP2.Int;
						}
					}
					break;
				case	MUL:
					{
					EvalNumStruct		TempEvalP1,TempEvalP2;

					TempEvalP1 = EvalExprNumTree(Temp.NodList[0]);
					TempEvalP2 = EvalExprNumTree(Temp.NodList[1]);

					if (TempEvalP1.Tip == TipFloat || TempEvalP2.Tip == TipFloat)
						{
						TempEval.Tip =	TipFloat;
						TempEval.Float =
								ConvertIntToFloat(TempEvalP1).Float *
								ConvertIntToFloat(TempEvalP2).Float;
						}
					else
						{
						TempEval.Tip =	TipInt;
						TempEval.Int = 	TempEvalP1.Int * TempEvalP2.Int;
						}
					}
					break;
				case	DIV:
					{
					EvalNumStruct		TempEvalP1,TempEvalP2;

					TempEvalP1 = EvalExprNumTree(Temp.NodList[0]);
					TempEvalP2 = EvalExprNumTree(Temp.NodList[1]);

					if (TempEvalP1.Tip == TipFloat || TempEvalP2.Tip == TipFloat)
						{
						TempEval.Tip =	TipFloat;
						TempEval.Float =
								ConvertIntToFloat(TempEvalP1).Float /
								ConvertIntToFloat(TempEvalP2).Float;
						}
					else
						{
						TempEval.Tip =	TipInt;
						TempEval.Int = 	TempEvalP1.Int / TempEvalP2.Int;
						}
					}
					break;
				case	MINUS:
					{
					TempEval = EvalExprNumTree(Temp.NodList[0]);

					switch( TempEval.Tip )
						{
						case TipInt:
							TempEval.Int = - TempEval.Int;
							break;
						case TipFloat:
							TempEval.Float = - TempEval.Float;
							break;
						default:
							yyerror("Executia nu poate ajunge in punctul acesta");
						}
					}
					break;
				default :
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
			}
			break;
		case TipNodVar:
			{
			VarNumNode	Temp=*((VarNumNode*)pNumTree);
			switch(Temp.pVar->Tip)
				{
				case TYPE_INT:
					TempEval.Tip = TipInt;
					TempEval.Int = Temp.pVar->Int;
					break;
				case TYPE_FLOAT:
					TempEval.Tip = TipFloat;
					TempEval.Float = Temp.pVar->Float;
					break;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
			}
			break;
		case TipNodCtInt:
			{
			CtIntNode	Temp=*((CtIntNode*)pNumTree);
			TempEval.Tip = TipInt;
			TempEval.Int = Temp.Val;
			}
			break;
		case TipNodCtFloat:
			{
			CtFloatNode	Temp=*((CtFloatNode*)pNumTree);
			TempEval.Tip = TipFloat;
			TempEval.Float = Temp.Val;
			}
			break;
		case TipNodNumFnc:
			TempEval = ExecNumFnc(((FncNumNode*)pNumTree)->pNumFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}

	return	TempEval;
	}


// Dezaloca un arbore numeric
void
	FreeNumTree( GenNumNode* pNumTree )
	{
	switch(pNumTree->Tip)
		{
		case TipNodOpr:
			{
			int			i;
			for ( i = 0 ; i< ((OprNumNode*)pNumTree)->NrOpd ; i++ )
				FreeNumTree(((OprNumNode*)pNumTree)->NodList[i]);
			free(pNumTree);
			}
			break;
		case TipNodVar:
		case TipNodCtInt:
		case TipNodCtFloat:
			free(pNumTree);
			break;
		case TipNodNumFnc:
			FreeNumFncNode(((FncNumNode*)pNumTree)->pNumFnc);
			free(pNumTree);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


/*------------------------------------------------------
*
*	Functii de gestiune a tipului boolean
*
*-----------------------------------------------------*/

// creaza un nod de tip operator boolean cu n operanzi
GenBoolNode*
	NewBoolOprNode	(
					long		TipOpr,
					long		NrOpd,
					...
					)
	{
	OprBoolNode*		pTempNode;
	GenBoolNode*		pTempGen;
	va_list				ArgList;
	int					i;

	pTempNode = (OprBoolNode*)malloc(sizeof(OprBoolNode)+(NrOpd-1)*sizeof(GenBoolNode*));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodOprBool;
	pTempNode->Opr = TipOpr;

	va_start(ArgList,NrOpd);
	for( i=0; i<NrOpd ; i++ )
		{
		pTempGen = va_arg(ArgList,GenBoolNode*);
		pTempNode->NodList[i] = pTempGen;
		}
	va_end(ArgList);

	return	(GenBoolNode*)pTempNode;
	}

// creaza un nod de tip comparatie intre doua expresii numerice
GenBoolNode*
	NewBoolCmpNode	(
					long			TipOpr,
					GenNumNode*		pFirst,
					GenNumNode*		pSecond
					)
	{
	CmpBoolNode*		pTempNode;

	pTempNode = (CmpBoolNode*)malloc(sizeof(CmpBoolNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodCmpBool;
	pTempNode->Opr = TipOpr;
	pTempNode->NodList[0] = pFirst;
	pTempNode->NodList[1] = pSecond;

	return	(GenBoolNode*)pTempNode;
	}


// creaza un nod de tip constanta booleana
GenBoolNode*
	NewCtBoolNode	(
					char		ValOpd
					)
	{
	CtBoolNode*		pTempNode;

	pTempNode = (CtBoolNode*)malloc(sizeof(CtBoolNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodCtBool;
	pTempNode->Val = ValOpd;

	return	(GenBoolNode*)pTempNode;
	}

// creaza un nod de tip variabila booleana
GenBoolNode*
	NewIdBoolNode	(
					VarList*		pIdOpd
					)
{
	VarBoolNode*		pTempNode;

	pTempNode = (VarBoolNode*)malloc(sizeof(VarBoolNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodVarBool;
	pTempNode->pVar = pIdOpd;

	return	(GenBoolNode*)pTempNode;
}


// evalueaza comparatia a doua expresii numerice
char
	CmpNumExpr(int	Opr, EvalNumStruct Num1,EvalNumStruct Num2)
	{
	char		Temp=0;

	if (Num1.Tip == TipFloat || Num2.Tip == TipFloat)
		{
		double		Temp1 = ConvertIntToFloat(Num1).Float;
		double		Temp2 = ConvertIntToFloat(Num2).Float;

		switch ( Opr )
			{
			case LT:	Temp =	Temp1<	Temp2;	break;
			case LE:	Temp =	Temp1<=	Temp2;	break;
			case GT:	Temp =	Temp1>	Temp2;	break;
			case GE:	Temp =	Temp1>=	Temp2;	break;
			case EQ:	Temp =	Temp1==	Temp2;	break;
			case NE:	Temp =	Temp1!=	Temp2;	break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		}
	else
		{
		long	Temp1 = Num1.Int;
		long	Temp2 = Num2.Int;

		switch ( Opr )
			{
			case LT:	Temp =	Temp1<	Temp2;	break;
			case LE:	Temp =	Temp1<=	Temp2;	break;
			case GT:	Temp =	Temp1>	Temp2;	break;
			case GE:	Temp =	Temp1>=	Temp2;	break;
			case EQ:	Temp =	Temp1==	Temp2;	break;
			case NE:	Temp =	Temp1!=	Temp2;	break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		}
	return Temp;
	}

// evalueaza un arbore de tip expresie booleana
char
	EvalExprBoolTree(GenBoolNode*		pBoolTree)
	{
	char		TempEval=0;

	switch(pBoolTree->Tip)
		{
		case TipNodCtBool:
			TempEval = ((CtBoolNode*)pBoolTree)->Val;
			break;
		case TipNodVarBool:
			TempEval = ((VarBoolNode*)pBoolTree)->pVar->Boolean;
			break;
		case TipNodOprBool:
			switch(((OprBoolNode*)pBoolTree)->Opr)
				{
				case	AND:
					TempEval =
						EvalExprBoolTree((GenBoolNode*)(((OprBoolNode*)pBoolTree)->NodList[0])) &&
						EvalExprBoolTree((GenBoolNode*)(((OprBoolNode*)pBoolTree)->NodList[1]));
					break;
				case	OR:
					TempEval =
						EvalExprBoolTree((GenBoolNode*)(((OprBoolNode*)pBoolTree)->NodList[0])) ||
						EvalExprBoolTree((GenBoolNode*)(((OprBoolNode*)pBoolTree)->NodList[1]));
					break;
				case	NOT:
					TempEval =
						!EvalExprBoolTree((GenBoolNode*)(((OprBoolNode*)pBoolTree)->NodList[0]));
					break;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
			break;
		case TipNodCmpBool:
			{
			EvalNumStruct		TempNumEvalP1,TempNumEvalP2;
			TempNumEvalP1 =
				EvalExprNumTree((GenNumNode*)((CmpBoolNode*)pBoolTree)->NodList[0]);
			TempNumEvalP2 =
				EvalExprNumTree((GenNumNode*)((CmpBoolNode*)pBoolTree)->NodList[1]);

			TempEval = CmpNumExpr(((CmpBoolNode*)pBoolTree)->Opr,TempNumEvalP1,TempNumEvalP2);
			}
			break;
		case TipNodBoolFnc:
			TempEval = ExecBoolFncNode(((FncBoolNode*)pBoolTree)->pBoolFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	return TempEval;
	}


// Dezaloca un arbore boolean
void
	FreeBoolTree( GenBoolNode* pBoolTree )
	{
	switch(pBoolTree->Tip)
		{
		case TipNodOprBool:
			{
			int			i;
			for ( i = 0 ; i< ((OprBoolNode*)pBoolTree)->NrOpd ; i++ )
				FreeBoolTree((GenBoolNode*)((OprBoolNode*)pBoolTree)->NodList[i]);
			free(pBoolTree);
			}
			break;
		case TipNodVarBool:
		case TipNodCtBool:
			free(pBoolTree);
			break;
		case TipNodCmpBool:
			FreeNumTree((GenNumNode*)((CmpBoolNode*)pBoolTree)->NodList[0]);
			FreeNumTree((GenNumNode*)((CmpBoolNode*)pBoolTree)->NodList[1]);
			free(pBoolTree);
			break;
		case TipNodBoolFnc:
			FreeBoolFncNode(((FncBoolNode*)pBoolTree)->pBoolFnc);
			free(pBoolTree);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}

/*------------------------------------------------------
*
*	Functii de gestiune a tipului string
*
*-----------------------------------------------------*/

// creaza un nod de tip constanta string
GenStrNode*
	NewCtStrNode	(
					char*		ValOpd
					)
	{
	CtStrNode*		pTempNode;

	pTempNode = (CtStrNode*)malloc(sizeof(CtStrNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodCtStr;
	pTempNode->Val = ValOpd;

	return	(GenStrNode*)pTempNode;
	}

// creaza un nod de tip variabila string
GenStrNode*
	NewIdStrNode	(
					VarList*		pIdOpd
					)
{
	VarStrNode*		pTempNode;

	pTempNode = (VarStrNode*)malloc(sizeof(VarStrNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodVarStr;
	pTempNode->pVar = pIdOpd;

	return	(GenStrNode*)pTempNode;
}


// creaza un nod de tip operator string cu n operanzi
GenStrNode*
	NewStrOprNode	(
					long		TipOpr,
					long		NrOpd,
					...
					)
	{
	OprStrNode*			pTempNode;
	GenStrNode*			pTempGen;
	va_list				ArgList;
	int					i;

	pTempNode = (OprStrNode*)malloc(sizeof(OprStrNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodOprStr;
	pTempNode->Opr = TipOpr;

	va_start(ArgList,NrOpd);
	for( i=0; i<NrOpd ; i++ )
		{
		pTempGen = va_arg(ArgList,GenStrNode*);
		pTempNode->NodList[i] = pTempGen;
		}
	va_end(ArgList);

	return	(GenStrNode*)pTempNode;
	}


// evalueaza un arbore de tip expresie string
char*
	EvalExprStrTree(GenStrNode*		pStrTree)
	{
	char*		TempEval=NULL;

	switch(pStrTree->Tip)
		{
		case TipNodStrFnc:
			TempEval = ExecStrFncNode(((FncStrNode*)pStrTree)->pStrFnc);
			break;
		case TipNodCtStr:
			TempEval = strdup(((CtStrNode*)pStrTree)->Val);
			break;
		case TipNodVarStr:
			TempEval = strdup(((VarStrNode*)pStrTree)->pVar->String);
			break;
		case TipNodOprStr:
			switch(((OprStrNode*)pStrTree)->Opr)
				{
				case	CONCAT:
					{
					char*	Temp1 = EvalExprStrTree(((OprStrNode*)pStrTree)->NodList[0]);
					char*	Temp2 = EvalExprStrTree(((OprStrNode*)pStrTree)->NodList[1]);
					TempEval = (char*)malloc(strlen(Temp1)+strlen(Temp2)+1);
					strcpy(TempEval,Temp1);
					strcat(TempEval,Temp2);
					free(Temp1);
					free(Temp2);
					}
					break;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	return TempEval;
	}

// dezaloca un arbore de tip expresie string
void
	FreeStrTree(GenStrNode*		pStrTree)
	{
	switch(pStrTree->Tip)
		{
		case TipNodStrFnc:
			FreeStrFncNode(((FncStrNode*)pStrTree)->pStrFnc);
			free(pStrTree);
			break;
		case TipNodCtStr:
			free(((CtStrNode*)pStrTree)->Val);
			free(pStrTree);
			break;
		case TipNodVarStr:
			free(pStrTree);
			break;
		case TipNodOprStr:
			switch(((OprStrNode*)pStrTree)->Opr)
				{
				case	CONCAT:
					FreeStrTree(((OprStrNode*)pStrTree)->NodList[0]);
					FreeStrTree(((OprStrNode*)pStrTree)->NodList[1]);
					free(pStrTree);
					break;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}

/*------------------------------------------------------
*
*	Functii de alocare a memoriei pentru instructiuni
*
*-----------------------------------------------------*/

// adauga un element la sfarsitul listei de intructiuni
GenInstElem*
	AddInstToList	(
					GenInstElem*		pInstList,
					GenInstElem*		pInstElem
					)
	{
	GenInstElem*	pTemp;

	if (!pInstList)		return	pInstElem;
	pTemp = pInstList;
	while(pTemp->pNext)
		pTemp = pTemp->pNext;
	pTemp->pNext = pInstElem;
	return pInstList;
	}

// creaza un element de tip intructiune assignare numerica
GenInstElem*
	NewAssignNumInst(
					VarList*			pNumId,
					GenNumNode*			pNumTree
					)
	{
	AssignNumInstElem*		pTempElem;
	pTempElem = (AssignNumInstElem*)malloc(sizeof(AssignNumInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstAttribNum;
	pTempElem->pNext = NULL;
	pTempElem->pVar = pNumId;
	pTempElem->pNumTree = pNumTree;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune assignare booleana
GenInstElem*
	NewAssignBoolInst(
					VarList*			pBoolId,
					GenBoolNode*		pBoolTree
					)
	{
	AssignBoolInstElem*		pTempElem;
	pTempElem = (AssignBoolInstElem*)malloc(sizeof(AssignBoolInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstAttribBool;
	pTempElem->pNext = NULL;
	pTempElem->pVar = pBoolId;
	pTempElem->pBoolTree = pBoolTree;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune assignare string
GenInstElem*
	NewAssignStrInst(
					VarList*			pStrId,
					GenStrNode*			pStrTree
					)
	{
	AssignStrInstElem*		pTempElem;
	pTempElem = (AssignStrInstElem*)malloc(sizeof(AssignStrInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstAttribStr;
	pTempElem->pNext = NULL;
	pTempElem->pVar = pStrId;
	pTempElem->pStrTree = pStrTree;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune while
GenInstElem*
	NewWhileInst	(
					GenBoolNode*		pBoolTree,
					GenInstElem*		pDoList
					)
	{
	WhileInstElem*		pTempElem;
	pTempElem = (WhileInstElem*)malloc(sizeof(WhileInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstWhile;
	pTempElem->pNext = NULL;
	pTempElem->pWhileTree = pBoolTree;
	pTempElem->pDoList = pDoList;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune 'for to step next'
GenInstElem*
	NewForToNextInst(
					VarList*				pVar,
					GenNumNode*				pBeginValue,
					GenNumNode*				pEndValue,
					GenNumNode*				pStepValue,
					GenInstElem*			pDoList
					)
	{
	ForToNextInstElem*		pTempElem;
	pTempElem = (ForToNextInstElem*)malloc(sizeof(ForToNextInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstForToNext;
	pTempElem->pNext = NULL;
	pTempElem->pVar = pVar;
	pTempElem->pBeginValue = pBeginValue;
	pTempElem->pEndValue = pEndValue;
	pTempElem->pStepValue = pStepValue;
	pTempElem->pDoList = pDoList;
	return	(GenInstElem*)pTempElem;
	}


// creaza un element de tip intructiune repeat
GenInstElem*
	NewRepeatInst	(
					GenBoolNode*		pBoolTree,
					GenInstElem*		pDoList
					)
	{
	RepeatInstElem*		pTempElem;
	pTempElem = (RepeatInstElem*)malloc(sizeof(RepeatInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstRepeat;
	pTempElem->pNext = NULL;
	pTempElem->pRepeatTree = pBoolTree;
	pTempElem->pDoList = pDoList;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element elseif pentru intructiunea if then else
ElseIfCell*
	NewElseIfCell	(
					GenBoolNode*		pElseIfTree,
					GenInstElem*		pElseIfDoList
					)
	{
	ElseIfCell*		pTempCell;
	pTempCell = (ElseIfCell*)malloc(sizeof(ElseIfCell));
	if (!pTempCell)
		yyerror("Memorie insuficienta\n");
	pTempCell->pElseIfTree = pElseIfTree;
	pTempCell->pElseIfDoList = pElseIfDoList;
	pTempCell->pNext = NULL;
	return	pTempCell;
	}

// adauga un element la sfarsitul listei elseif
ElseIfCell*
	AddElseIfToList	(
					ElseIfCell*		pElseIfList,
					ElseIfCell*		pElseIfElem
					)
	{
	ElseIfCell*	pTemp;

	if (!pElseIfList)		return	pElseIfElem;
	pTemp = pElseIfList;
	while(pTemp->pNext)
		pTemp = pTemp->pNext;
	pTemp->pNext = pElseIfElem;
	return pElseIfList;
	}

// creaza un element de tip intructiune if then else
GenInstElem*
	NewIfThenElseInst	(
						GenBoolNode*		pIfBoolTree,
						GenInstElem*		pIdDoList,
						ElseIfCell*			pElseIfList,
						GenInstElem*		pElseDoList
						)
	{
	IfThenElseInstElem*		pTempElem;
	pTempElem = (IfThenElseInstElem*)malloc(sizeof(IfThenElseInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstIfThenElse;
	pTempElem->pNext = NULL;
	pTempElem->pIfTree = pIfBoolTree;
	pTempElem->pIfDoList = pIdDoList;
	pTempElem->pElseIfList = pElseIfList;
	pTempElem->pElseDoList = pElseDoList;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune break
GenInstElem*
	NewBreakInst	(
					void
					)
	{
	BreakInstElem*		pTempElem;
	pTempElem = (BreakInstElem*)malloc(sizeof(BreakInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstBreak;
	pTempElem->pNext = NULL;
	return	(GenInstElem*)pTempElem;
	}

// creaza un element de tip intructiune exit
GenInstElem*
	NewExitInst		(
					void
					)
	{
	ExitInstElem*		pTempElem;
	pTempElem = (ExitInstElem*)malloc(sizeof(ExitInstElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipInstExit;
	pTempElem->pNext = NULL;
	return	(GenInstElem*)pTempElem;
	}


// alocarea unei structuri de tip program
Program*
	NewProgram	(
				char*		strPrgName
				)
	{
	Program*			pTemp;

	pTemp = (Program*)malloc(sizeof(Program));
	if (!pTemp)
		yyerror("Memorie insuficienta\n");
	pTemp->pVarList = (VarList*)NULL;
	pTemp->pParamList = (VarList*)NULL;
	pTemp->pInstrList = (GenInstElem*)NULL;
	pTemp->pCaller = (Program*)NULL;
	pTemp->LineNo = 1;
	pTemp->strPrgName = strdup(strPrgName);
	return pTemp;
	}

/*------------------------------------------------------
*
*	Functii de executie a intructiunilor
*
*-----------------------------------------------------*/

// Executa o intructiune de asignare numerica
void
	ExecuteAssignNumInstr	(
							GenInstElem*		pInstr
							)
	{
	AssignNumInstElem*		pTemp=(AssignNumInstElem*)pInstr;
	EvalNumStruct			TempEval;

	TempEval = EvalExprNumTree(pTemp->pNumTree);
	switch(pTemp->pVar->Tip)
		{
		case TYPE_INT:
			pTemp->pVar->Int = ConvertFloatToInt(TempEval).Int;
			break;
		case TYPE_FLOAT:
			pTemp->pVar->Float = ConvertIntToFloat(TempEval).Float;
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}

// Executa o intructiune de asignare booleana
void
	ExecuteAssignBoolInstr	(
							GenInstElem*		pInstr
							)
	{
	AssignBoolInstElem*		pTemp=(AssignBoolInstElem*)pInstr;
	pTemp->pVar->Boolean = EvalExprBoolTree(pTemp->pBoolTree);
	}

// Executa o intructiune de asignare string
void
	ExecuteAssignStrInstr	(
							GenInstElem*		pInstr
							)
	{
	char* pTemp = (((AssignStrInstElem*)pInstr)->pVar)->String;
	(((AssignStrInstElem*)pInstr)->pVar)->String =
			EvalExprStrTree(((AssignStrInstElem*)pInstr)->pStrTree);
	free(pTemp);
	}

// Executa o intructiune 'if then else'
void
	ExecuteIfThenElseInstr	(
							GenInstElem*		pInstr
							)
	{
	IfThenElseInstElem*		pTemp=(IfThenElseInstElem*)pInstr;
	ElseIfCell*				pTempElseIf=pTemp->pElseIfList;

	// ramura if
	if (EvalExprBoolTree(pTemp->pIfTree))
		ExecuteInstrList(pTemp->pIfDoList);
	else
		{
		// ramurile elseif
		while(pTempElseIf)
			{
			if(EvalExprBoolTree(pTempElseIf->pElseIfTree))
				{
				ExecuteInstrList(pTempElseIf->pElseIfDoList);
				break;
				}
			pTempElseIf=pTempElseIf->pNext;
			}
		// ramura else
		if(!pTempElseIf && pTemp->pElseDoList)
			ExecuteInstrList(pTemp->pElseDoList);
		}
	}

// Executa o intructiune while
void
	ExecuteWhileInstr	(
						GenInstElem*		pInstr
						)
	{
	WhileInstElem*		pTemp=(WhileInstElem*)pInstr;

	while (EvalExprBoolTree(pTemp->pWhileTree))
		ExecuteInstrList(pTemp->pDoList);
	}

// Executa o intructiune repeat
void
	ExecuteRepeatInstr	(
						GenInstElem*		pInstr
						)
	{
	RepeatInstElem*		pTemp=(RepeatInstElem*)pInstr;

	do
		ExecuteInstrList(pTemp->pDoList);
	while(!EvalExprBoolTree(pTemp->pRepeatTree));
	}

// Executa o intructiune 'for to step next'
void
	ExecuteForToNextInstr	(
							GenInstElem*		pInstr
							)
	{
	ForToNextInstElem*		pTemp=(ForToNextInstElem*)pInstr;
	EvalNumStruct			BeginTempEval;
	EvalNumStruct			EndTempEval;
	EvalNumStruct			StepTempEval;

	BeginTempEval = EvalExprNumTree(pTemp->pBeginValue);
	EndTempEval = EvalExprNumTree(pTemp->pEndValue);
	if ( pTemp->pStepValue )
		StepTempEval = EvalExprNumTree(pTemp->pStepValue);
	else
		{
		StepTempEval.Tip = TipInt;
		StepTempEval.Int = 1;
		}

	switch(pTemp->pVar->Tip)
		{
		case TYPE_INT:
			if( ConvertFloatToInt(StepTempEval).Int>=0 )
				for (
						pTemp->pVar->Int = ConvertFloatToInt(BeginTempEval).Int;
						pTemp->pVar->Int <= ConvertFloatToInt(EndTempEval).Int;
						pTemp->pVar->Int += ConvertFloatToInt(StepTempEval).Int
					)
							ExecuteInstrList(pTemp->pDoList);
			else
				for (
						pTemp->pVar->Int = ConvertFloatToInt(BeginTempEval).Int;
						pTemp->pVar->Int >= ConvertFloatToInt(EndTempEval).Int;
						pTemp->pVar->Int += ConvertFloatToInt(StepTempEval).Int
					)
							ExecuteInstrList(pTemp->pDoList);
			break;
		case TYPE_FLOAT:
			if( ConvertIntToFloat(StepTempEval).Float>=0 )
				for (
						pTemp->pVar->Float = ConvertIntToFloat(BeginTempEval).Float;
						pTemp->pVar->Float <= ConvertIntToFloat(EndTempEval).Float;
						pTemp->pVar->Float += ConvertIntToFloat(StepTempEval).Float
					)
							ExecuteInstrList(pTemp->pDoList);
			else
				for (
						pTemp->pVar->Float = ConvertIntToFloat(BeginTempEval).Float;
						pTemp->pVar->Float >= ConvertIntToFloat(EndTempEval).Float;
						pTemp->pVar->Float += ConvertIntToFloat(StepTempEval).Float
					)
							ExecuteInstrList(pTemp->pDoList);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}

// functie de executie pt. intructiune exit
void
	ExecuteExitInstr	(
						GenInstElem*		pInstr
						)
	{
	throw new ExceptionExit;
	}

// functie de executie pt. intructiune break
void
	ExecuteBreakInstr	(
						GenInstElem*		pInstr
						)
	{
	throw new ExceptionBreak;
	}


// executa lista de intructiuni
void
	ExecuteInstrList	(
						GenInstElem*		pInstrList
						)
	{
	GenInstElem*	pTemp;

	pTemp = pInstrList;
	while(pTemp)
		{
		switch(pTemp->Tip)
			{
			case TipInstAttribNum:
				ExecuteAssignNumInstr(pTemp);
				break;
			case TipInstAttribBool:
				ExecuteAssignBoolInstr(pTemp);
				break;
			case TipInstAttribStr:
				ExecuteAssignStrInstr(pTemp);
				break;
			case TipInstIfThenElse:
				ExecuteIfThenElseInstr(pTemp);
				break;
			case TipInstWhile:
				try
				{ExecuteWhileInstr(pTemp);}
				catch (ExceptionBreak* E){E->dummy();}
				break;
			case TipInstRepeat:
				try
				{ExecuteRepeatInstr(pTemp);}
				catch (ExceptionBreak* E){E->dummy();}
				break;
			case TipInstForToNext:
				try
				{ExecuteForToNextInstr(pTemp);}
				catch (ExceptionBreak* E){E->dummy();}
				break;
			case TipInstBreak:
				ExecuteBreakInstr(pTemp);
				break;
			case TipInstExit:
				ExecuteExitInstr(pTemp);
				break;
			case TipFncCall:
				ExecuteFncCallInstr(pTemp);
				break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		pTemp = pTemp->pNext;
		}
	}

// executa programul
void
	ExecuteProgram		(
						Program*			pPrg
						)
	{
	if (!pPrg) return;
	try
	{ExecuteInstrList(pPrg->pInstrList);}
	catch (ExceptionBreak* E){E->dummy();}
	catch (ExceptionExit* E){E->dummy();}
	}

/*------------------------------------------------------
*
*	Functii de dezalocare a memoriei folosite de instructiuni
*
*-----------------------------------------------------*/

// elibereaza memoria alocata de un arbore expresie numerica
void
	FreeAssignNumInstr	(
						GenInstElem*		pInstr
						)
	{
	FreeNumTree(((AssignNumInstElem*)pInstr)->pNumTree);
	free(pInstr);
	}

// elibereaza memoria alocata de un arbore expresie booleana
void
	FreeAssignBoolInstr	(
						GenInstElem*		pInstr
						)
	{
	FreeBoolTree(((AssignBoolInstElem*)pInstr)->pBoolTree);
	free(pInstr);
	}

// elibereaza memoria alocata de un arbore expresie string
void
	FreeAssignStrInstr	(
						GenInstElem*		pInstr
						)
	{
	FreeStrTree(((AssignStrInstElem*)pInstr)->pStrTree);
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea 'if then else'
void
	FreeIfThenElseInstr	(
						GenInstElem*		pInstr
						)
	{
	ElseIfCell* pTemp = ((IfThenElseInstElem*)pInstr)->pElseIfList;

	FreeBoolTree(((IfThenElseInstElem*)pInstr)->pIfTree);
	FreeInstrList(((IfThenElseInstElem*)pInstr)->pIfDoList);
	while(pTemp)
		{
		FreeBoolTree(pTemp->pElseIfTree);
		FreeInstrList(pTemp->pElseIfDoList);
		pTemp=pTemp->pNext;
		}
	if (((IfThenElseInstElem*)pInstr)->pElseDoList)
		FreeInstrList(((IfThenElseInstElem*)pInstr)->pElseDoList);
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea while
void
	FreeWhileInstr	(
					GenInstElem*		pInstr
					)
	{
	FreeBoolTree(((WhileInstElem*)pInstr)->pWhileTree);
	FreeInstrList(((WhileInstElem*)pInstr)->pDoList);
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea repeat
void
	FreeRepeatInstr	(
					GenInstElem*		pInstr
					)
	{
	FreeBoolTree(((RepeatInstElem*)pInstr)->pRepeatTree);
	FreeInstrList(((RepeatInstElem*)pInstr)->pDoList);
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea 'for to next'
void
	FreeForToNextInstr	(
						GenInstElem*		pInstr
						)
	{
	FreeNumTree(((ForToNextInstElem*)pInstr)->pBeginValue);
	FreeNumTree(((ForToNextInstElem*)pInstr)->pEndValue);
	if(((ForToNextInstElem*)pInstr)->pStepValue)
		FreeNumTree(((ForToNextInstElem*)pInstr)->pStepValue);
	FreeInstrList(((ForToNextInstElem*)pInstr)->pDoList);
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea break
void
	FreeBreakInstr	(
					GenInstElem*		pInstr
					)
	{
	free(pInstr);
	}

// elibereaza memoria alocata de intructiunea exit
void
	FreeExitInstr	(
					GenInstElem*		pInstr
					)
	{
	free(pInstr);
	}


// elibereaza memoria alocata de lista de intructiuni
void
	FreeInstrList	(
					GenInstElem*		pInstrList
					)
	{
	GenInstElem*	pTemp = pInstrList;

	if ( !pTemp ) return;
	if ( pTemp->pNext )
			FreeInstrList(pTemp->pNext);
	switch(pTemp->Tip)
		{
		case TipInstAttribNum:
			FreeAssignNumInstr(pTemp);
			break;
		case TipInstAttribBool:
			FreeAssignBoolInstr(pTemp);
			break;
		case TipInstAttribStr:
			FreeAssignStrInstr(pTemp);
			break;
		case TipInstIfThenElse:
			FreeIfThenElseInstr(pTemp);
			break;
		case TipInstWhile:
			FreeWhileInstr(pTemp);
			break;
		case TipInstRepeat:
			FreeRepeatInstr(pTemp);
			break;
		case TipInstForToNext:
			FreeForToNextInstr(pTemp);
			break;
		case TipInstBreak:
			FreeBreakInstr(pTemp);
			break;
		case TipInstExit:
			FreeExitInstr(pTemp);
			break;
		case TipFncCall:
			FreeFncCallInstr(pTemp);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


// elibereaza memoria alocata de lista de intructiuni
void
	FreeProgram		(
					Program*		pPrg
					)
	{
	if (!pPrg) return;
	FreeVarList(pPrg);
	FreeParamList(pPrg);
	FreeInstrList(pPrg->pInstrList);
	free(pPrg->strPrgName);
	free(pPrg);
	}
