#include	"main.h"





/*******************************************************
*
*	Gestiunea parametrilor de functii
*
*******************************************************/
// creaza un element de tip parametru numeric
Param*
	NewParamExprNum	(
					GenNumNode*			pNumTree
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamExprNum;
	pTempElem->pNumTree = pNumTree;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}
// creaza un element de tip parametru boolean
Param*
	NewParamExprBool(
					GenBoolNode*		pBoolTree
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamExprBool;
	pTempElem->pBoolTree = pBoolTree;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// creaza un element de tip parametru string
Param*
	NewParamExprStr	(
					GenStrNode*			pStrTree
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamExprStr;
	pTempElem->pStrTree = pStrTree;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// creaza un element de tip parametru variabila int
Param*
	NewParamIdInt	(
					VarList*		pIntVar
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamIdInt;
	pTempElem->pIntVar = pIntVar;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// creaza un element de tip parametru variabila float
Param*
	NewParamIdFloat	(
					VarList*		pFloatVar
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamIdFloat;
	pTempElem->pFloatVar = pFloatVar;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// creaza un element de tip parametru variabila string
Param*
	NewParamIdStr	(
					VarList*		pStrVar
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamIdString;
	pTempElem->pStrVar = pStrVar;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// creaza un element de tip parametru variabila booleana
Param*
	NewParamIdBool	(
					VarList*		pBoolVar
					)
	{
	Param*			pTempElem;
	pTempElem = (Param*)malloc(sizeof(Param));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipParamIdBool;
	pTempElem->pBoolVar = pBoolVar;
	pTempElem->pNext = (Param*)NULL;
	return	(Param*)pTempElem;
	}

// elibereaza memoria pentru un element de tip parametru
void
	FreeParam		(
					Param*		pParam
					)
	{
	switch(pParam->Tip)
		{
		case		TipParamExprNum:
			FreeNumTree(pParam->pNumTree);
			break;
		case		TipParamExprBool:
			FreeBoolTree(pParam->pBoolTree);
			break;
		case		TipParamExprStr:
			FreeStrTree(pParam->pStrTree);
			break;
		case		TipParamIdInt:
		case		TipParamIdFloat:
		case		TipParamIdString:
		case		TipParamIdBool:
			// nimic
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	free(pParam);
	}

// adauga un parametru la lista de parametrii
Param*
	AddParamToParamList	(
						Param*		pParamList,
						Param*		pParam
						)
	{
	Param*	pTemp;

	if (!pParamList)		return pParam;
	pTemp = pParamList;
	while(pTemp->pNext)
		pTemp = pTemp->pNext;
	pTemp->pNext = pParam;
	return pParamList;
	}



/*******************************************************
*
*	Alocare memorie pentru elemente de tip
*		expresie numerica, expresie booleana, expresie strnig
*
*******************************************************/
// creaza un nod expresie numerica de tip functie numerica
GenNumNode*
	NewNumFncNode	(
					GenFncElem*		pNumFnc
					)
{
	FncNumNode*		pTempNode;

	pTempNode = (FncNumNode*)malloc(sizeof(FncNumNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodNumFnc;
	pTempNode->pNumFnc = pNumFnc;

	return	(GenNumNode*)pTempNode;
}

// creaza un nod expresie booleana de tip functie booleana
GenBoolNode*
	NewBoolFncNode	(
					GenFncElem*		pBoolFnc
					)
{
	FncBoolNode*		pTempNode;

	pTempNode = (FncBoolNode*)malloc(sizeof(FncBoolNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodBoolFnc;
	pTempNode->pBoolFnc = pBoolFnc;

	return	(GenBoolNode*)pTempNode;
}

// creaza un nod "expr_str" de tip functie string
GenStrNode*
	NewStrFncNode	(
					GenFncElem*		pStrFnc
					)
	{
	FncStrNode*		pTempNode;

	pTempNode = (FncStrNode*)malloc(sizeof(FncStrNode));
	if (!pTempNode)
		yyerror("Memorie insuficienta\n");
	pTempNode->Tip = TipNodStrFnc;
	pTempNode->pStrFnc = pStrFnc;
	return	(GenStrNode*)pTempNode;
	}


/*--------------------------------------------------------------
*
*	Functii cu rezultat numeric
*
*-------------------------------------------------------------*/
// creaza un element de tip functie "ZileLucratoare"
GenFncElem*
	NewFncNum1Elem	(
					GenNumNode*		pAn,
					GenNumNode*		pLuna
					)
	{
	FncNum1FncElem*		pTempElem;
	pTempElem = (FncNum1FncElem*)malloc(sizeof(FncNum1FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipFncNum1Fnc;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	return	(GenFncElem*)pTempElem;
	}


// creaza un element de tip functie "GrilaImpozit"
GenFncElem*
	NewFncNum2Elem	(
					GenNumNode*		pSuma
					)
	{
	FncNum2FncElem*		pTempElem;
	pTempElem = (FncNum2FncElem*)malloc(sizeof(FncNum2FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipFncNum2Fnc;
	pTempElem->pSuma = pSuma;
	return	(GenFncElem*)pTempElem;
	}

/*--------------------------------------------------------------
*
*	Functii cu rezultat boolean
*
*-------------------------------------------------------------*/
// creaza un element de tip functie "AngajatCC"
GenFncElem*
	NewFncBool1Elem	(
					GenNumNode*		pAngajat,
					GenNumNode*		pFirma,
					GenNumNode*		pAn,
					GenNumNode*		pLuna,
					VarList*		pOL,
					VarList*		pOS,
					VarList*		pOCO,
					VarList*		pOP,
					VarList*		pPB,
					VarList*		pPP
					)
	{
	FncBool1FncElem*		pTempElem;
	pTempElem = (FncBool1FncElem*)malloc(sizeof(FncBool1FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncBool1Fnc;
	pTempElem->pAngajat = pAngajat;
	pTempElem->pFirma = pFirma;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	pTempElem->pOL = pOL;
	pTempElem->pOS = pOS;
	pTempElem->pOCO = pOCO;
	pTempElem->pOP = pOP;
	pTempElem->pPB = pPB;
	pTempElem->pPP = pPP;
	return	(GenFncElem*)pTempElem;
	}

// creaza un element de tip functie "AngajatNegociere"
GenFncElem*
	NewFncBool2Elem	(
					GenNumNode*		pAngajat,
					GenNumNode*		pFirma,
					GenNumNode*		pAn,
					GenNumNode*		pLuna,
					VarList*		pSB,
					VarList*		pSN,
					VarList*		pValuta
					)
	{
	FncBool2FncElem*		pTempElem;
	pTempElem = (FncBool2FncElem*)malloc(sizeof(FncBool2FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncBool2Fnc;
	pTempElem->pAngajat = pAngajat;
	pTempElem->pFirma = pFirma;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	pTempElem->pSB = pSB;
	pTempElem->pSN = pSN;
	pTempElem->pValuta = pValuta;
	return	(GenFncElem*)pTempElem;
	}

// creaza un element de tip functie "DeducereGenerala"
GenFncElem*
	NewFncBool3Elem	(
					GenNumNode*		pAn,
					GenNumNode*		pLuna,
					VarList*		pDPB,
					VarList*		pCCP,
					VarList*		pPlafCAS
					)
	{
	FncBool3FncElem*		pTempElem;
	pTempElem = (FncBool3FncElem*)malloc(sizeof(FncBool3FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncBool3Fnc;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	pTempElem->pDPB = pDPB;
	pTempElem->pCCP = pCCP;
	pTempElem->pPlafCAS = pPlafCAS;
	return	(GenFncElem*)pTempElem;
	}

// creaza un element de tip functie "DeducereSuplimentara"
GenFncElem*
	NewFncBool4Elem	(
					GenNumNode*		pAngajat,
					GenNumNode*		pAn,
					GenNumNode*		pLuna,
					VarList*		pSCDED
					)
	{
	FncBool4FncElem*		pTempElem;
	pTempElem = (FncBool4FncElem*)malloc(sizeof(FncBool4FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncBool4Fnc;
	pTempElem->pAngajat = pAngajat;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	pTempElem->pSCDED = pSCDED;
	return	(GenFncElem*)pTempElem;
	}


// creaza un element de tip functie "AngajatInfoIncadrare"
GenFncElem*
	NewFncBool5Elem	(
					GenNumNode*		pAngajat,
					GenNumNode*		pAn,
					GenNumNode*		pLuna,
					VarList*		pTipContract,
					VarList*		pCondLucru,
					VarList*		pCoefCondLucru
					)
	{
	FncBool5FncElem*		pTempElem;
	pTempElem = (FncBool5FncElem*)malloc(sizeof(FncBool5FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncBool5Fnc;
	pTempElem->pAngajat = pAngajat;
	pTempElem->pAn = pAn;
	pTempElem->pLuna = pLuna;
	pTempElem->pTipContract = pTipContract;
	pTempElem->pCondLucru = pCondLucru;
	pTempElem->pCoefCondLucru = pCoefCondLucru;
	return	(GenFncElem*)pTempElem;
	}

// creaza un element de tip functie "Strcmp"
GenFncElem*
	NewFncStrcmpElem(
					GenStrNode*		pStr1,
					GenStrNode*		pStr2
					)
	{
	StrcmpFncElem*		pTempElem;
	pTempElem = (StrcmpFncElem*)malloc(sizeof(StrcmpFncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipStrcmpFnc;
	pTempElem->pStr1 = pStr1;
	pTempElem->pStr2 = pStr2;
	return	(GenFncElem*)pTempElem;
	}
/*--------------------------------------------------------------
*
*	Functii cu rezultat string
*
*-------------------------------------------------------------*/
// creaza un element de tip functie VB  mid
GenFncElem*
	NewFncStr1Elem	(
					GenStrNode*		pStr,
					GenNumNode*		pFirst,
					GenNumNode*		pLength
					)
	{
	FncStr1FncElem*		pTempElem;
	pTempElem = (FncStr1FncElem*)malloc(sizeof(FncStr1FncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = 	TipFncStr1Fnc;
	pTempElem->pStr = pStr;
	pTempElem->pFirst = pFirst;
	pTempElem->pLength = pLength;
	return	(GenFncElem*)pTempElem;
	}


/*--------------------------------------------------------------
*
*	Functii fara rezultat
*
*-------------------------------------------------------------*/
// creaza un element de tip functie "print"
GenFncElem*
	NewPrintFncElem	(
					GenStrNode*			pParam1,
					Param*				pParam2
					)
	{
	PrintFncElem*		pTempElem;
	pTempElem = (PrintFncElem*)malloc(sizeof(PrintFncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipPrintFnc;
	pTempElem->pParam1 = pParam1;
	pTempElem->pParam2 = pParam2;
	return	(GenFncElem*)pTempElem;
	}

// creaza un element de tip functie "ExecProgram"
GenFncElem*
	NewExecPrgElem	(
					char*			PrgName,
					Param*			pParamList
					)
	{
	ExecPrgFncElem*			pTempElem;
	Program					*pPrg;
	void*					pBuff;
	int						parseRez;

	pTempElem = (ExecPrgFncElem*)malloc(sizeof(ExecPrgFncElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipExecPrgFnc;
	pTempElem->PrgName = PrgName;
	pTempElem->pParamList = pParamList;
	pTempElem->pPrg = (Program*)NULL;

	try
		{
		pPrg = NewProgram(PrgName);
		pBuff = AllocBuffer(PrgName);
		PushBuffer(pBuff);
		}
	catch(ExceptionProgramNotFound* E)
		{
		E->dummy();
		FreeProgram(pPrg);
		pTempElem->pPrg = (Program*)NULL;
		return	(GenFncElem*)pTempElem;
		}
	catch(ExceptionCallMaxDeepExceed* E)
		{
		E->dummy();
		FreeProgram(pPrg);
		free(pBuff);
		return	(GenFncElem*)pTempElem;
		}

	pPrg->pCaller = pCurrentProgram;
	pCurrentProgram = pPrg;
	OutputMsg("-------Parse program: \"%s\"-------\n",pPrg->strPrgName);
	parseRez = yyparse((void*)pPrg);
	FreeBuffer(PopBuffer());
	pCurrentProgram = pPrg->pCaller;
	if(!parseRez)
	{
		pTempElem->pPrg = pPrg;
		if (!VerifyProgramParams(pTempElem))
			{
			FreeProgram(pPrg);
			pTempElem->pPrg = (Program*)NULL;
			}
		}
	//
	//	Daca parseRez e TRUE inseamna ca a fost eroare la parse
	//
	return	(GenFncElem*)pTempElem;
	}

// verifica corespondenta intre parametrii formali si cei actuali
bool
	VerifyProgramParams	(
						ExecPrgFncElem*		pPrgFnc
						)
	{
	bool		bRet=TRUE;
	int			PrmNo=1;
	if (!pPrgFnc->pPrg)	return FALSE;
	// parametrii actuali
	Param*		pTempActParam = pPrgFnc->pParamList;
	// parametrii formali
	VarList*	pTempFrmParam = pPrgFnc->pPrg->pParamList;

	while(pTempActParam && pTempFrmParam)
		{
		switch(pTempFrmParam->Tip)
			{
			case TYPE_INT:
				switch(pTempFrmParam->TipSpec)
					{
					case	TipByVal:
						if (	pTempActParam->Tip != TipParamExprNum &&
								pTempActParam->Tip != TipParamIdInt )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie expresie numerica sau variabila de tip integer\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					case	TipByRef:
						if ( pTempActParam->Tip != TipParamIdInt )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie variabila de tip integer\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				break;
			case TYPE_FLOAT:
				switch(pTempFrmParam->TipSpec)
					{
					case	TipByVal:
						if (	pTempActParam->Tip != TipParamExprNum &&
								pTempActParam->Tip != TipParamIdFloat )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie expresie numerica sau variabila de tip float\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					case	TipByRef:
						if ( pTempActParam->Tip != TipParamIdFloat )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie variabila de tip float\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				break;
			case TYPE_STRING:
				switch(pTempFrmParam->TipSpec)
					{
					case	TipByVal:
						if (	pTempActParam->Tip != TipParamExprStr &&
								pTempActParam->Tip != TipParamIdString )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie expresie string sau variabila de tip string\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					case	TipByRef:
						if ( pTempActParam->Tip != TipParamIdString )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie variabila de tip string\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				break;
			case TYPE_BOOL:
				switch(pTempFrmParam->TipSpec)
					{
					case	TipByVal:
						if (	pTempActParam->Tip != TipParamExprBool &&
								pTempActParam->Tip != TipParamIdBool )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie expresie booleana sau variabila de tip boolean\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					case	TipByRef:
						if ( pTempActParam->Tip != TipParamIdBool )
							{
							OutputMsg("Apel \"%s\" param %d trebuie sa fie variabila de tip boolean\n",pPrgFnc->pPrg->strPrgName, PrmNo);
							bRet = FALSE;
							}
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		PrmNo++;
		pTempActParam = pTempActParam->pNext;
		pTempFrmParam = pTempFrmParam->pNext;
		}
	if(pTempActParam || pTempFrmParam)
		{
		OutputMsg("Apel \"%s\" numar de parametrii diferit",pPrgFnc->pPrg->strPrgName);
		bRet = FALSE;
		}

	if (!bRet)
		{
		OutputMsg("Apel \"%s\" Eroare: tipul sau numarul parametrilor incorect\n",pPrgFnc->pPrg->strPrgName);
		}

	return bRet;
	}


// transmite valorile parametrilor actuali catre cei formali
void
	SetProgramParams	(
						ExecPrgFncElem*		pPrgFnc
						)
	{
	if (!pPrgFnc->pPrg)	return;
	// parametrii actuali
	Param*		pTempActParam = pPrgFnc->pParamList;
	// parametrii formali
	VarList*	pTempFrmParam = pPrgFnc->pPrg->pParamList;
	EvalNumStruct			TempNum;
	char*					TempStr=NULL;
	char					TempBool;

	while(pTempActParam && pTempFrmParam)
		{
		switch(pTempFrmParam->Tip)
			{
			case	TYPE_INT:
			case	TYPE_FLOAT:
				switch(pTempActParam->Tip)
					{
					case TipParamExprNum:
						TempNum = EvalExprNumTree(pTempActParam->pNumTree);
						break;
					case TipParamIdInt:
						TempNum.Tip = TipInt;
						TempNum.Int = pTempActParam->pIntVar->Int;
						break;
					case TipParamIdFloat:
						TempNum.Tip = TipFloat;
						TempNum.Float = pTempActParam->pIntVar->Float;
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				if( pTempFrmParam->Tip == TYPE_INT )
					pTempFrmParam->Int = ConvertFloatToInt(TempNum).Int;
				if( pTempFrmParam->Tip == TYPE_FLOAT )
					pTempFrmParam->Float = ConvertIntToFloat(TempNum).Float;
				break;
			case	TYPE_STRING:
				switch(pTempActParam->Tip)
					{
					case TipParamExprStr:
						TempStr = EvalExprStrTree(pTempActParam->pStrTree);
						break;
					case TipParamIdString:
						TempStr = strdup(pTempActParam->pIntVar->String);
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				free(pTempFrmParam->String);
				pTempFrmParam->String = TempStr;
				break;
			case	TYPE_BOOL:
				switch(pTempActParam->Tip)
					{
					case TipParamExprBool:
						TempBool = EvalExprBoolTree(pTempActParam->pBoolTree);
						break;
					case TipParamIdBool:
						TempBool = pTempActParam->pIntVar->Boolean;
						break;
					default:
						yyerror("Executia nu poate ajunge in punctul acesta");
					}
				pTempFrmParam->Boolean = TempBool;
				break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		pTempActParam = pTempActParam->pNext;
		pTempFrmParam = pTempFrmParam->pNext;
		}
	}

// transmite valorile parametrilor formali catre cei actuali
void
	GetProgramParams	(
						ExecPrgFncElem*		pPrgFnc
						)
	{
	if (!pPrgFnc->pPrg)	return;
	// parametrii actuali
	Param*		pTempActParam = pPrgFnc->pParamList;
	// parametrii formali
	VarList*	pTempFrmParam = pPrgFnc->pPrg->pParamList;

	while(pTempActParam && pTempFrmParam)
		{
		if(pTempFrmParam->TipSpec == TipByRef)
			switch(pTempFrmParam->Tip)
				{
				case	TYPE_INT:
					pTempActParam->pIntVar->Int = pTempFrmParam->Int;
					break;
				case	TYPE_FLOAT:
					pTempActParam->pFloatVar->Float = pTempFrmParam->Float;
					break;
				case	TYPE_STRING:
					free(pTempActParam->pStrVar->String);
					pTempActParam->pStrVar->String = strdup(pTempFrmParam->String);
					break;
				case	TYPE_BOOL:
					pTempActParam->pBoolVar->Boolean = pTempFrmParam->Boolean;
					break;
				default:
					yyerror("Executia nu poate ajunge in punctul acesta");
				}
		pTempActParam = pTempActParam->pNext;
		pTempFrmParam = pTempFrmParam->pNext;
		}
	}




/*--------------------------------------------------------------
*
*	Alocare memorie intructiuni de tip functie
*
*-------------------------------------------------------------*/
// creaza un element de tip apel functie
GenInstElem*
	NewFncCallInst	(
					GenFncElem*				pFnc
					)
	{
	FncCallElem*		pTempElem;
	pTempElem = (FncCallElem*)malloc(sizeof(FncCallElem));
	if (!pTempElem)
		yyerror("Memorie insuficienta\n");
	pTempElem->Tip = TipFncCall;
	pTempElem->pNext = NULL;
	pTempElem->pFnc = pFnc;
	return	(GenInstElem*)pTempElem;
	}



/*******************************************************
*
*	Functii de executie a elementelor de tip functie
*
*******************************************************/

/*--------------------------------------------------------------
*
*	Functii fara rezultat
*
*-------------------------------------------------------------*/
// executa functia print
void
	ExecFncPrint	(
					GenFncElem*		pFnc
					)
	{
	PrintFncElem*		pTemp=(PrintFncElem*)pFnc;
	char*				pParam1=EvalExprStrTree(pTemp->pParam1);

	if(pTemp->pParam2)
		{
		switch(pTemp->pParam2->Tip)
			{
			case TipParamExprNum:
				{
				EvalNumStruct	TempEval=EvalExprNumTree(pTemp->pParam2->pNumTree);
				if(TempEval.Tip == TipInt)
					{
					OutputMsg(pParam1,TempEval.Int);
					}
				else
					{
					OutputMsg(pParam1,TempEval.Float);
					}
				}
				break;
			case TipParamExprBool:
				OutputMsg(EvalExprBoolTree(pTemp->pParam2->pBoolTree) ? "TRUE":"FALSE");
				break;
			case TipParamExprStr:
				{
				char*	pTempEval = EvalExprStrTree(pTemp->pParam2->pStrTree);
				OutputMsg(pParam1,pTempEval);
				free(pTempEval);
				}
				break;
			default:
				yyerror("Executia nu poate ajunge in punctul acesta");
			}
		}
	else
		{
		OutputMsg(pParam1);
		}

	free(pParam1);
	}

// executa functia 'ExecProgram'
void
	ExecExecPrgFnc	(
					GenFncElem*		pFnc
					)
	{
	ExecPrgFncElem*		pTemp=(ExecPrgFncElem*)pFnc;

	if (pTemp->pPrg)
		{
		SetProgramParams(pTemp);
		ExecuteProgram(pTemp->pPrg);
		GetProgramParams(pTemp);
		}
	else
		{
		OutputMsg("Programul \"%s\" nu poate fi executat\n",pTemp->PrgName);
		}
	}

/*--------------------------------------------------------------
*
*	Executie functii cu rezultat numeric
*
*-------------------------------------------------------------*/
// executa functia ZileLucratoare
EvalNumStruct
	ExecFncNum1Fnc		(
					GenFncElem*		pFnc
					)
	{
	FncNum1FncElem*		pTemp=(FncNum1FncElem*)pFnc;
	EvalNumStruct		An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct		Luna=EvalExprNumTree(pTemp->pLuna);
	EvalNumStruct		nsRet;

	nsRet.Tip = TipInt;
	nsRet.Int = MyFnc1
			(
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int
			);

	return	nsRet;
	}


// executa functia GrilaImpozitare
EvalNumStruct
	ExecFncNum2Fnc	(
					GenFncElem*		pFnc
					)
	{
	FncNum2FncElem*		pTemp=(FncNum2FncElem*)pFnc;
	EvalNumStruct		Suma=EvalExprNumTree(pTemp->pSuma);
	EvalNumStruct		nsRet;

	nsRet.Tip = TipFloat;
	nsRet.Float = MyFnc6
			(
			ConvertIntToFloat(Suma).Float
			);

	return	nsRet;
	}

/*--------------------------------------------------------------
*
*	Executie functii cu rezultat boolean
*
*-------------------------------------------------------------*/
// executa functia AngajatCentralizatorContabilitate
char
	ExecFncBool1	(
					GenFncElem*		pFnc
					)
	{
	FncBool1FncElem*		pTemp=(FncBool1FncElem*)pFnc;
	EvalNumStruct			Angajat=EvalExprNumTree(pTemp->pAngajat);
	EvalNumStruct			Firma=EvalExprNumTree(pTemp->pFirma);
	EvalNumStruct			An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct			Luna=EvalExprNumTree(pTemp->pLuna);
	double					OL,OS,OCO,OP,PB,PP;
	bool					bRet;

	bRet =
		MyFnc2
			(
			ConvertFloatToInt(Angajat).Int,
			ConvertFloatToInt(Firma).Int,
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int,
			&OL,&OS,&OCO,&OP,&PB,&PP
			);
	pTemp->pOL->Float = OL;
	pTemp->pOS->Float = OS;
	pTemp->pOCO->Float = OCO;
	pTemp->pOP->Float = OP;
	pTemp->pPB->Float = PB;
	pTemp->pPP->Float = PP;

	return (char)bRet;
	}

// executa functia AngajatNegociere
char
	ExecFncBool2	(
					GenFncElem*		pFnc
					)
	{
	FncBool2FncElem*		pTemp=(FncBool2FncElem*)pFnc;
	EvalNumStruct			Angajat=EvalExprNumTree(pTemp->pAngajat);
	EvalNumStruct			Firma=EvalExprNumTree(pTemp->pFirma);
	EvalNumStruct			An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct			Luna=EvalExprNumTree(pTemp->pLuna);
	double					SB,SN;
	char*					pValuta;
	bool					bRet;

	bRet =
		MyFnc3
			(
			ConvertFloatToInt(Angajat).Int,
			ConvertFloatToInt(Firma).Int,
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int,
			&SB,&SN,&pValuta
			);
	if (bRet)
		{
		pTemp->pSB->Float = SB;
		pTemp->pSN->Float = SN;
		free(pTemp->pValuta->String);
		pTemp->pValuta->String = pValuta;
		}

	return (char)bRet;
	}

// executa functia DeducereGenerala
char
	ExecFncBool3	(
					GenFncElem*		pFnc
					)
	{
	FncBool3FncElem*		pTemp=(FncBool3FncElem*)pFnc;
	EvalNumStruct			An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct			Luna=EvalExprNumTree(pTemp->pLuna);
	double					DPB,CCP,PlafCAS;
	bool					bRet;

	bRet =
		MyFnc4
			(
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int,
			&DPB,
			&CCP,
			&PlafCAS
			);
	pTemp->pDPB->Float = DPB;
	pTemp->pCCP->Float = CCP;
	pTemp->pPlafCAS->Float = PlafCAS;


	return (char)bRet;
	}

// executa functia DeducereSuplimentara
char
	ExecFncBool4	(
					GenFncElem*		pFnc
					)
	{
	FncBool4FncElem*		pTemp=(FncBool4FncElem*)pFnc;
	EvalNumStruct			Angajat=EvalExprNumTree(pTemp->pAngajat);
	EvalNumStruct			An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct			Luna=EvalExprNumTree(pTemp->pLuna);
	double					SCDED;
	bool					bRet;

	bRet =
		MyFnc5
			(
			ConvertFloatToInt(Angajat).Int,
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int,
			&SCDED
			);
	pTemp->pSCDED->Float = SCDED;

	return (char)bRet;
	}

// executa functia "AngajatInfoIncadrare"
char
	ExecFncBool5	(
					GenFncElem*		pFnc
					)
	{
	FncBool5FncElem*		pTemp=(FncBool5FncElem*)pFnc;
	EvalNumStruct			Angajat=EvalExprNumTree(pTemp->pAngajat);
	EvalNumStruct			An=EvalExprNumTree(pTemp->pAn);
	EvalNumStruct			Luna=EvalExprNumTree(pTemp->pLuna);
	char*					pTipContract;
	char*					pCondLucru;
	double					CoefCondLucru;
	bool					bRet;

	bRet =
		MyFnc7
			(
			ConvertFloatToInt(Angajat).Int,
			ConvertFloatToInt(An).Int,
			ConvertFloatToInt(Luna).Int,
			&pTipContract,
			&pCondLucru,
			&CoefCondLucru
			);

	if ( bRet )
		{
		free(pTemp->pTipContract->String);
		pTemp->pTipContract->String = pTipContract;
		free(pTemp->pCondLucru->String);
		pTemp->pCondLucru->String = pCondLucru;
		pTemp->pCoefCondLucru->Float = CoefCondLucru;
		}

	return (char)bRet;
	}

// executa functia "Strcmp"
char
	ExecFncStrcmp	(
					GenFncElem*		pFnc
					)
	{
	StrcmpFncElem*			pTemp=(StrcmpFncElem*)pFnc;
	char*					pStr1 = EvalExprStrTree(pTemp->pStr1);
	char*					pStr2 = EvalExprStrTree(pTemp->pStr2);
	bool					bRet;

	bRet = !_stricmp(pStr1,pStr2);
	free(pStr1);
	free(pStr2);

	return (char)bRet;
	}

/*--------------------------------------------------------------
*
*	Executie functii cu rezultat string
*
*-------------------------------------------------------------*/
// executa functia MID
char*
	ExecFncStr1		(
					GenFncElem*		pFnc
					)
	{
	FncStr1FncElem*			pTemp=(FncStr1FncElem*)pFnc;
	char*					Str=EvalExprStrTree(pTemp->pStr);
	long					First=ConvertFloatToInt(EvalExprNumTree(pTemp->pFirst)).Int;
	long					Length=ConvertFloatToInt(EvalExprNumTree(pTemp->pLength)).Int;
	long					StrLength=strlen(Str);
	long					NewStrLength;
	char*					strRet;

	if ( First<0 || Length<1 )
		strRet = strdup("");
	else
		{
		NewStrLength=__min(__max(StrLength-First+1,0),Length);
		strRet = (char*)malloc(NewStrLength+1);
		memset(strRet,0,NewStrLength+1);
		if (First<=StrLength)
			memcpy(strRet,Str+First-1,__min(Length,StrLength-First+1));
		}
	return strRet;
	}


// executa functii cu rezultat numeric
EvalNumStruct
	ExecNumFnc		(
					GenFncElem*		pNumFnc
					)
	{
	EvalNumStruct	Temp;

	switch (pNumFnc->Tip)
		{
		case	TipFncNum1Fnc:
			Temp = ExecFncNum1Fnc(pNumFnc);
			break;
		case	TipFncNum2Fnc:
			Temp = ExecFncNum2Fnc(pNumFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}

	return	Temp;
	}

// executa functii cu rezultat boolean
char
	ExecBoolFncNode	(
					GenFncElem*		pBoolFnc
					)
	{
	char		Temp;

	switch (pBoolFnc->Tip)
		{
		case	TipFncBool1Fnc:
			Temp = ExecFncBool1(pBoolFnc);
			break;
		case TipFncBool2Fnc:
			Temp = ExecFncBool2(pBoolFnc);
			break;
		case TipFncBool3Fnc:
			Temp = ExecFncBool3(pBoolFnc);
			break;
		case TipFncBool4Fnc:
			Temp = ExecFncBool4(pBoolFnc);
			break;
		case TipFncBool5Fnc:
			Temp = ExecFncBool5(pBoolFnc);
			break;
		case TipStrcmpFnc:
			Temp = ExecFncStrcmp(pBoolFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}

	return	Temp;
	}

// executa functii cu rezultat string
char*
	ExecStrFncNode	(
					GenFncElem*		pStrFnc
					)
	{
	char*		Temp=NULL;

	switch (pStrFnc->Tip)
		{
		case	TipFncStr1Fnc:
			Temp = ExecFncStr1(pStrFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}

	return	Temp;
	}

/*******************************************************
*
*	Functii de eliberare a elementelor de tip functie
*
*******************************************************/
// elibereaza memoria alocata de functia print
void
	FreeFncPrint	(
					GenFncElem*		pFnc
					)
	{
	PrintFncElem*		pTemp=(PrintFncElem*)pFnc;

	FreeStrTree(pTemp->pParam1);
	if(pTemp->pParam2)	FreeParam(pTemp->pParam2);
	free(pFnc);
	}

// elibereaza memoria alocata de functia ExecPogram
void
	FreeExecPrgFnc	(
					GenFncElem*		pFnc
					)
	{
	ExecPrgFncElem*		pTemp=(ExecPrgFncElem*)pFnc;
	Param*				pTempParam;

	FreeProgram(pTemp->pPrg);
	free(pTemp->PrgName);
	while(pTemp->pParamList)
		{
		pTempParam = pTemp->pParamList;
		pTemp->pParamList = pTemp->pParamList->pNext;
		FreeParam(pTempParam);
		}
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_NUM_1
void
	FreeFncNum1Fnc	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncNum1FncElem*)pFnc)->pAn);
	FreeNumTree(((FncNum1FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_NUM_2
void
	FreeFncNum2Fnc	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncNum2FncElem*)pFnc)->pSuma);
	free(pFnc);
	}


// elibereaza memoria alocata de functia FNC_BOOL_1
void
	FreeFncBool1	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncBool1FncElem*)pFnc)->pAngajat);
	FreeNumTree(((FncBool1FncElem*)pFnc)->pFirma);
	FreeNumTree(((FncBool1FncElem*)pFnc)->pAn);
	FreeNumTree(((FncBool1FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_BOOL_2
void
	FreeFncBool2	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncBool2FncElem*)pFnc)->pAngajat);
	FreeNumTree(((FncBool2FncElem*)pFnc)->pFirma);
	FreeNumTree(((FncBool2FncElem*)pFnc)->pAn);
	FreeNumTree(((FncBool2FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_BOOL_3
void
	FreeFncBool3	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncBool3FncElem*)pFnc)->pAn);
	FreeNumTree(((FncBool3FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_BOOL_4
void
	FreeFncBool4	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncBool4FncElem*)pFnc)->pAngajat);
	FreeNumTree(((FncBool4FncElem*)pFnc)->pAn);
	FreeNumTree(((FncBool4FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia FNC_BOOL_5
void
	FreeFncBool5	(
					GenFncElem*		pFnc
					)
	{
	FreeNumTree(((FncBool4FncElem*)pFnc)->pAngajat);
	FreeNumTree(((FncBool4FncElem*)pFnc)->pAn);
	FreeNumTree(((FncBool4FncElem*)pFnc)->pLuna);
	free(pFnc);
	}

// elibereaza memoria alocata de functia Strcmp
void
	FreeFncStrcmp	(
					GenFncElem*		pFnc
					)
	{
	FreeStrTree(((StrcmpFncElem*)pFnc)->pStr1);
	FreeStrTree(((StrcmpFncElem*)pFnc)->pStr2);
	free(pFnc);
	}

// elibereaza memoria alocata de functia MID
void
	FreeFncStr1		(
					GenFncElem*		pFnc
					)
	{
	FreeStrTree(((FncStr1FncElem*)pFnc)->pStr);
	FreeNumTree(((FncStr1FncElem*)pFnc)->pFirst);
	FreeNumTree(((FncStr1FncElem*)pFnc)->pLength);
	free(pFnc);
	}


/*******************************************************
*
*	Functii de executie a instructiunilor de tip functie
*
*******************************************************/
// functie de executie pt. elemente de tip functie
void
	ExecuteFncCallInstr	(
						GenInstElem*		pInstr
						)
	{
	FncCallElem*	pTemp=(FncCallElem*)pInstr;

	switch(pTemp->pFnc->Tip)
		{
		case TipPrintFnc:
			ExecFncPrint(pTemp->pFnc);
			break;
		case TipExecPrgFnc:
			ExecExecPrgFnc(pTemp->pFnc);
			break;
		case	TipFncNum1Fnc:
			ExecFncNum1Fnc(pTemp->pFnc);
			break;
		case	TipFncNum2Fnc:
			ExecFncNum2Fnc(pTemp->pFnc);
			break;
		case	TipFncBool1Fnc:
			ExecFncBool1(pTemp->pFnc);
			break;
		case	TipFncBool2Fnc:
			ExecFncBool2(pTemp->pFnc);
			break;
		case	TipFncBool3Fnc:
			ExecFncBool3(pTemp->pFnc);
			break;
		case	TipFncBool4Fnc:
			ExecFncBool4(pTemp->pFnc);
			break;
		case	TipFncBool5Fnc:
			ExecFncBool5(pTemp->pFnc);
			break;
		case	TipStrcmpFnc:
			ExecFncStrcmp(pTemp->pFnc);
			break;
		case	TipFncStr1Fnc:
			free(ExecFncStr1(pTemp->pFnc));
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


/*******************************************************
*
*	Functii de eliberare a instructiunilor de tip functie
*
*******************************************************/
// elibereaza memoria alocata de intructiunea de tip functie
void
	FreeFncCallInstr	(
						GenInstElem*		pInstr
						)
	{
	FncCallElem*		pTemp=(FncCallElem*)pInstr;

	switch(pTemp->pFnc->Tip)
		{
		case TipPrintFnc:
			FreeFncPrint(pTemp->pFnc);
			break;
		case TipExecPrgFnc:
			FreeExecPrgFnc(pTemp->pFnc);
			break;
		case	TipFncNum1Fnc:
			FreeFncNum1Fnc(pTemp->pFnc);
			break;
		case	TipFncNum2Fnc:
			FreeFncNum2Fnc(pTemp->pFnc);
			break;
		case	TipFncBool1Fnc:
			FreeFncBool1(pTemp->pFnc);
			break;
		case	TipFncBool2Fnc:
			FreeFncBool2(pTemp->pFnc);
			break;
		case	TipFncBool3Fnc:
			FreeFncBool3(pTemp->pFnc);
			break;
		case	TipFncBool4Fnc:
			FreeFncBool4(pTemp->pFnc);
			break;
		case	TipFncBool5Fnc:
			FreeFncBool5(pTemp->pFnc);
			break;
		case	TipStrcmpFnc:
			FreeFncStrcmp(pTemp->pFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	free(pInstr);
	}


// elibereaza memoria alocata de un nod numeric de tip functie
// functii ce intorc valoare numerica
void
	FreeNumFncNode		(
						GenFncElem*		pNumFnc
						)
	{
	switch(pNumFnc->Tip)
		{
		case	TipFncNum1Fnc:
			FreeFncNum1Fnc(pNumFnc);
			break;
		case	TipFncNum2Fnc:
			FreeFncNum2Fnc(pNumFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


// elibereaza memoria alocata de un nod boolean de tip functie
// functii ce intorc valoare booleana
void
	FreeBoolFncNode		(
						GenFncElem*			pBoolFnc
						)
	{
	switch(pBoolFnc->Tip)
		{
		case	TipFncBool1Fnc:
			FreeFncBool1(pBoolFnc);
			break;
		case	TipFncBool2Fnc:
			FreeFncBool2(pBoolFnc);
			break;
		case	TipFncBool3Fnc:
			FreeFncBool3(pBoolFnc);
			break;
		case	TipFncBool4Fnc:
			FreeFncBool4(pBoolFnc);
			break;
		case	TipFncBool5Fnc:
			FreeFncBool5(pBoolFnc);
			break;
		case	TipStrcmpFnc:
			FreeFncStrcmp(pBoolFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}


// elibereaza memoria alocata "expr_str" de tip functie
// functii ce intorc valoare srting
void
	FreeStrFncNode		(
						GenFncElem*			pStrFnc
						)
	{
	switch(pStrFnc->Tip)
		{
		case	TipFncStr1Fnc:
			FreeFncStr1(pStrFnc);
			break;
		default:
			yyerror("Executia nu poate ajunge in punctul acesta");
		}
	}
